# vim: set sts=4 ts=4 sw=4 et nojs: */
import os
import sys

g_SectorsPerCluster = 8

def main():
    print("Please let me know what you want to do by entering a number or a command.")
    command_dict = { "1" : process_cluster, "cluster" : process_cluster }
    while True:
        print("1 (cluster). Calculates cluster to sector mapping, and generates a `dd'")
        print("command line.")
        print("0 (quit). Quits the program.")
        print("Your choice:")
        line = sys.stdin.readline()
        if line == "":
            break
        line = line.rstrip("\n")
        if line in command_dict:
            command_dict[line]()
        elif line in ["0", "quit"]:
            break
    return 0

def process_cluster():
    print("Please enter the cluster number:")
    while True:
        try:
            cluster_no = int(sys.stdin.readline().rstrip("\n"))
            break
        except:
            print("Please enter an integer.")
    print("The sector number is: {0}".format(cluster_no * g_SectorsPerCluster))
    print("The dd command line:")
    cmd_exe_line = "dd if=\\\\?\\Device\\HarddiskDmVolumes\\Nt5vmwareDg0\\Volume1 of=dump{0}.dat skip={0} count={1}".format(cluster_no * g_SectorsPerCluster, g_SectorsPerCluster)
    print(cmd_exe_line)
    rosh_line = read_from_pipe("echopl " + cmd_exe_line + " | roshesc2 -s").rstrip("\n")
    print(rosh_line)
    sys.stdout.write("Copy one of the dd command lines onto the clipboard? [C/R/N] ")
    sys.stdout.flush()
    while True:
        line = sys.stdin.readline().rstrip("\n")
        if line.lower() == "c":
            write_to_pipe("cpsio", cmd_exe_line)
            break
        elif line.lower() == "r":
            write_to_pipe("cpsio", rosh_line)
            break
        elif line.lower() == "n":
            break
        print("Please check your answer and try again.")

def read_from_pipe(pipe_cmd):
    pipe = None
    try:
        pipe = os.popen(pipe_cmd, "r")
        return pipe.read()
    finally:
        if pipe != None:
            pipe.close()

def write_to_pipe(pipe_cmd, str):
    pipe = None
    try:
        pipe = os.popen(pipe_cmd, "w")
        pipe.write(str)
    finally:
        if pipe != None:
            pipe.close()

sys.exit(main())
